"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createConfig = createConfig;

function _utils() {
  const data = require("@parcel/utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _Environment() {
  const data = require("./Environment");

  _Environment = function () {
    return data;
  };

  return data;
}

function createConfig({
  plugin,
  isSource,
  searchPath,
  env,
  result,
  includedFiles,
  invalidateOnFileCreate,
  invalidateOnOptionChange,
  devDeps,
  shouldInvalidateOnStartup
}) {
  let environment = env !== null && env !== void 0 ? env : (0, _Environment().createEnvironment)();
  return {
    id: (0, _utils().md5FromString)(plugin + searchPath + environment.id + String(isSource)),
    isSource: isSource !== null && isSource !== void 0 ? isSource : false,
    searchPath,
    env: environment,
    result: result !== null && result !== void 0 ? result : null,
    resultHash: null,
    includedFiles: includedFiles !== null && includedFiles !== void 0 ? includedFiles : new Set(),
    invalidateOnFileCreate: invalidateOnFileCreate !== null && invalidateOnFileCreate !== void 0 ? invalidateOnFileCreate : [],
    invalidateOnOptionChange: invalidateOnOptionChange !== null && invalidateOnOptionChange !== void 0 ? invalidateOnOptionChange : new Set(),
    devDeps: devDeps !== null && devDeps !== void 0 ? devDeps : [],
    shouldInvalidateOnStartup: shouldInvalidateOnStartup !== null && shouldInvalidateOnStartup !== void 0 ? shouldInvalidateOnStartup : false
  };
}